> ## Documentation Index
> Fetch the complete documentation index at: https://docs.runaether.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Get the task conversation snapshot



## OpenAPI

````yaml api-reference/openapi.v1.json GET /tasks/{taskID}/conversation
openapi: 3.1.0
info:
  title: Aether Public API
  version: 0.1.0
  description: >-
    The versioned, public Aether REST API. Authenticate with an `aether_`
    platform API key or a session token.
servers:
  - url: https://api.runaether.dev/v1
security:
  - bearerAuth: []
paths:
  /tasks/{taskID}/conversation:
    get:
      tags:
        - tasks
      summary: Get the task conversation snapshot
      operationId: getTaskConversation
      parameters:
        - in: path
          name: taskID
          required: true
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                additionalProperties: false
                properties:
                  activeProcessingTurn:
                    anyOf:
                      - $ref: >-
                          #/components/schemas/TaskConversationActiveProcessingTurn
                      - type: 'null'
                  activity:
                    items:
                      $ref: '#/components/schemas/TaskActivityItem'
                    type: array
                  latestSequence:
                    format: int64
                    maximum: 9007199254740991
                    minimum: 0
                    type: integer
                  messages:
                    items:
                      $ref: '#/components/schemas/TaskTimelineMessage'
                    type: array
                  task:
                    discriminator:
                      mapping:
                        awaiting_input:
                          $ref: '#/components/schemas/TaskAwaitingInput'
                        errored:
                          $ref: '#/components/schemas/TaskErrored'
                        processing:
                          $ref: '#/components/schemas/TaskProcessing'
                        queued:
                          $ref: '#/components/schemas/TaskQueued'
                      propertyName: status
                    oneOf:
                      - $ref: '#/components/schemas/TaskQueued'
                      - $ref: '#/components/schemas/TaskProcessing'
                      - $ref: '#/components/schemas/TaskAwaitingInput'
                      - $ref: '#/components/schemas/TaskErrored'
                  toolCalls:
                    items:
                      $ref: '#/components/schemas/TaskConversationToolCall'
                    type: array
                required:
                  - task
                  - messages
                  - activity
                  - activeProcessingTurn
                  - latestSequence
                  - toolCalls
                type: object
          description: OK
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unauthorized
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Not Found
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unprocessable Entity
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Internal Server Error
components:
  schemas:
    TaskConversationActiveProcessingTurn:
      additionalProperties: false
      properties:
        messageId:
          minLength: 1
          type: string
        startedAt:
          minLength: 1
          type: string
      required:
        - messageId
        - startedAt
      type: object
    TaskActivityItem:
      discriminator:
        mapping:
          ci_failed:
            $ref: '#/components/schemas/TaskActivityCIFailed'
          ci_passed:
            $ref: '#/components/schemas/TaskActivityCIPassed'
          done:
            $ref: '#/components/schemas/TaskActivityDone'
          error:
            $ref: '#/components/schemas/TaskActivityError'
          question:
            $ref: '#/components/schemas/TaskActivityQuestion'
          start_task:
            $ref: '#/components/schemas/TaskActivityStartTask'
          workspace_lifecycle:
            $ref: '#/components/schemas/TaskActivityWorkspaceLifecycle'
        propertyName: type
      oneOf:
        - $ref: '#/components/schemas/TaskActivityDone'
        - $ref: '#/components/schemas/TaskActivityError'
        - $ref: '#/components/schemas/TaskActivityQuestion'
        - $ref: '#/components/schemas/TaskActivityStartTask'
        - $ref: '#/components/schemas/TaskActivityWorkspaceLifecycle'
        - $ref: '#/components/schemas/TaskActivityCIPassed'
        - $ref: '#/components/schemas/TaskActivityCIFailed'
    TaskTimelineMessage:
      oneOf:
        - $ref: '#/components/schemas/TaskTimelineUserMessage'
        - $ref: '#/components/schemas/TaskTimelineTextMessage'
        - $ref: '#/components/schemas/TaskTimelineThinkingMessage'
        - $ref: '#/components/schemas/TaskTimelineToolMessage'
    TaskAwaitingInput:
      additionalProperties: false
      properties:
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        awaiting_input:
          $ref: '#/components/schemas/TaskAwaitingInputPayload'
        created_at:
          minLength: 1
          type: string
        display_status:
          enum:
            - running
            - awaiting_input
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        last_error:
          type:
            - string
            - 'null'
        latest_sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - awaiting_input
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type: string
      required:
        - id
        - project_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - status
        - display_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - run_context
        - awaiting_input
      type: object
    TaskErrored:
      additionalProperties: false
      properties:
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        completed_at:
          minLength: 1
          type: string
        created_at:
          minLength: 1
          type: string
        display_status:
          enum:
            - running
            - awaiting_input
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        error:
          minLength: 1
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        last_error:
          type:
            - string
            - 'null'
        latest_sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - errored
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type: string
      required:
        - id
        - project_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - status
        - display_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - run_context
        - error
        - completed_at
      type: object
    TaskProcessing:
      additionalProperties: false
      properties:
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        created_at:
          minLength: 1
          type: string
        display_status:
          enum:
            - running
            - awaiting_input
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        last_error:
          type:
            - string
            - 'null'
        latest_sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          $ref: '#/components/schemas/TaskRunContext'
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - processing
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type: string
      required:
        - id
        - project_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - status
        - display_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - run_context
      type: object
    TaskQueued:
      additionalProperties: false
      properties:
        agent_type:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        archived_at:
          minLength: 1
          type:
            - string
            - 'null'
        auto_fix_ci:
          type: boolean
        auto_fix_pr_comments:
          type: boolean
        auto_rebase:
          type: boolean
        created_at:
          minLength: 1
          type: string
        display_status:
          enum:
            - running
            - awaiting_input
            - awaiting_ci
            - merged
            - unmerged
            - errored
            - archived
          type: string
        feed_updated_at:
          minLength: 1
          type: string
        hardware:
          $ref: '#/components/schemas/HardwareConfig'
        head_branch:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        interaction_mode:
          enum:
            - default
            - plan
          type: string
        last_error:
          type:
            - string
            - 'null'
        latest_sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        latest_status_message:
          type:
            - string
            - 'null'
        latest_status_source:
          type:
            - string
            - 'null'
        model:
          minLength: 1
          type: string
        name:
          minLength: 1
          type: string
        primary_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskPullRequest'
            - type: 'null'
        project_id:
          minLength: 1
          type: string
        pull_requests:
          items:
            $ref: '#/components/schemas/TaskPullRequest'
          type: array
        reasoning_effort:
          enum:
            - ultra
            - max
            - xhigh
            - high
            - medium
            - low
            - ultrathink
            - ultracode
            - none
          type:
            - string
            - 'null'
        review_subject_pull_request:
          anyOf:
            - $ref: '#/components/schemas/TaskReviewSubjectPullRequest'
            - type: 'null'
        run_context:
          anyOf:
            - $ref: '#/components/schemas/TaskRunContext'
            - type: 'null'
        runtime_timing:
          $ref: '#/components/schemas/TaskRuntimeTiming'
        slash_commands:
          items:
            $ref: '#/components/schemas/TaskSlashCommand'
          type:
            - array
            - 'null'
        source:
          $ref: '#/components/schemas/TaskSource'
        source_metadata:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        status:
          enum:
            - queued
          type: string
        usage:
          $ref: '#/components/schemas/TaskUsage'
        user_id:
          minLength: 1
          type: string
      required:
        - id
        - project_id
        - user_id
        - name
        - agent_type
        - model
        - interaction_mode
        - auto_fix_ci
        - auto_fix_pr_comments
        - auto_rebase
        - status
        - display_status
        - pull_requests
        - primary_pull_request
        - review_subject_pull_request
        - usage
        - runtime_timing
        - hardware
        - source
        - created_at
        - feed_updated_at
        - run_context
      type: object
    TaskConversationToolCall:
      additionalProperties: false
      properties:
        createdAt:
          minLength: 1
          type: string
        display:
          $ref: '#/components/schemas/ToolDisplay'
        error:
          type: string
        id:
          minLength: 1
          type: string
        input:
          additionalProperties: true
          properties: {}
          type: object
        itemType:
          enum:
            - user_message
            - assistant_message
            - reasoning
            - plan
            - command_execution
            - file_change
            - file_read
            - mcp_tool_call
            - dynamic_tool_call
            - collab_agent_tool_call
            - web_search
            - web_fetch
            - image_view
            - task_tracking
            - subagent_invocation
            - review_entered
            - review_exited
            - context_compaction
            - error
            - unknown
          type: string
        name:
          minLength: 1
          type: string
        result:
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        status:
          enum:
            - input-streaming
            - input-available
            - output-available
            - output-error
            - output-denied
            - approval-responded
            - approval-requested
          type: string
        turnId:
          minLength: 1
          type: string
        updatedAt:
          minLength: 1
          type: string
      required:
        - id
        - sequence
        - name
        - status
        - input
        - display
        - createdAt
        - updatedAt
      type: object
    ErrorResponse:
      additionalProperties: false
      properties:
        code:
          type: string
        error:
          minLength: 1
          type: string
      required:
        - error
      type: object
    TaskActivityCIFailed:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/CIFailedEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - ci_failed
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityCIPassed:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/CIPassedEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - ci_passed
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityDone:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/DoneEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - done
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityError:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/ErrorEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - error
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityQuestion:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/QuestionEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - question
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityStartTask:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          additionalProperties: true
          properties: {}
          type:
            - object
            - 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - start_task
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskActivityWorkspaceLifecycle:
      additionalProperties: false
      properties:
        created_at:
          minLength: 1
          type: string
        data:
          anyOf:
            - $ref: '#/components/schemas/WorkspaceLifecycleEventData'
            - type: 'null'
        event_id:
          minLength: 1
          type: string
        id:
          minLength: 1
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        task_id:
          minLength: 1
          type: string
        type:
          enum:
            - workspace_lifecycle
          type: string
      required:
        - id
        - task_id
        - created_at
        - sequence
        - type
        - data
      type: object
    TaskTimelineUserMessage:
      additionalProperties: false
      properties:
        clientMessageId:
          format: uuid
          type: string
        content:
          type: string
        context:
          $ref: '#/components/schemas/PromptContext'
        deliveryStatus:
          enum:
            - queued
            - processing
            - processed
          type: string
        id:
          minLength: 1
          type: string
        messageEvent:
          $ref: '#/components/schemas/MessageEventCard'
        processingStartedAt:
          minLength: 1
          type: string
        role:
          enum:
            - user
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        timestamp:
          minLength: 1
          type: string
        toolResponse:
          discriminator:
            mapping:
              ask_user:
                $ref: '#/components/schemas/AskUserToolResponse'
              propose_plan:
                $ref: '#/components/schemas/ProposePlanToolResponse'
            propertyName: tool_name
          oneOf:
            - $ref: '#/components/schemas/AskUserToolResponse'
            - $ref: '#/components/schemas/ProposePlanToolResponse'
        variant:
          enum:
            - text
          type: string
      required:
        - id
        - role
        - content
        - deliveryStatus
        - timestamp
        - sequence
      type: object
    TaskTimelineTextMessage:
      additionalProperties: false
      properties:
        content:
          type: string
        id:
          minLength: 1
          type: string
        role:
          enum:
            - assistant
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        timestamp:
          minLength: 1
          type: string
        variant:
          enum:
            - text
          type: string
      required:
        - id
        - role
        - variant
        - timestamp
        - sequence
        - content
      type: object
    TaskTimelineThinkingMessage:
      additionalProperties: false
      properties:
        content:
          type: string
        duration:
          format: double
          minimum: 0
          type: number
        id:
          minLength: 1
          type: string
        isStreaming:
          type: boolean
        role:
          enum:
            - assistant
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        timestamp:
          minLength: 1
          type: string
        variant:
          enum:
            - thinking
          type: string
      required:
        - id
        - role
        - variant
        - timestamp
        - sequence
        - content
        - isStreaming
      type: object
    TaskTimelineToolMessage:
      additionalProperties: false
      properties:
        id:
          minLength: 1
          type: string
        role:
          enum:
            - assistant
          type: string
        sequence:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        timestamp:
          minLength: 1
          type: string
        tool:
          $ref: '#/components/schemas/TaskTimelineTool'
        variant:
          enum:
            - tool
          type: string
      required:
        - id
        - role
        - variant
        - timestamp
        - sequence
        - tool
      type: object
    TaskAwaitingInputPayload:
      discriminator:
        mapping:
          message:
            $ref: '#/components/schemas/TaskAwaitingInputMessage'
          plan:
            $ref: '#/components/schemas/TaskAwaitingInputPlan'
          questions:
            $ref: '#/components/schemas/TaskAwaitingInputQuestions'
        propertyName: kind
      oneOf:
        - $ref: '#/components/schemas/TaskAwaitingInputMessage'
        - $ref: '#/components/schemas/TaskAwaitingInputQuestions'
        - $ref: '#/components/schemas/TaskAwaitingInputPlan'
    HardwareConfig:
      additionalProperties: false
      properties:
        cpu_kind:
          enum:
            - shared
            - performance
          type: string
        cpus:
          format: int64
          maximum: 16
          minimum: 1
          type: integer
        gpu_kind:
          enum:
            - a10
            - l40s
            - a100-40gb
            - a100-80gb
          type:
            - string
            - 'null'
        memory_mb:
          format: int64
          maximum: 32768
          minimum: 256
          type: integer
        volume_size_gb:
          format: int64
          maximum: 500
          minimum: 1
          type: integer
      required:
        - cpu_kind
        - cpus
        - memory_mb
        - volume_size_gb
        - gpu_kind
      type: object
    TaskPullRequest:
      additionalProperties: false
      properties:
        additions:
          format: int64
          minimum: 0
          type: integer
        branch_name:
          minLength: 1
          type: string
        checks_failed:
          format: int64
          minimum: 0
          type: integer
        checks_passed:
          format: int64
          minimum: 0
          type: integer
        checks_total:
          format: int64
          minimum: 0
          type: integer
        ci_status:
          enum:
            - pending
            - passed
            - failed
          type: string
        commits:
          format: int64
          minimum: 0
          type: integer
        deletions:
          format: int64
          minimum: 0
          type: integer
        html_url:
          minLength: 1
          type: string
        lines_changed:
          format: int64
          minimum: 0
          type: integer
        pr_number:
          format: int64
          minimum: 1
          type: integer
        state:
          enum:
            - open
            - closed
            - merged
          type: string
        title:
          type: string
      required:
        - pr_number
        - html_url
        - title
        - checks_passed
        - checks_failed
        - checks_total
        - commits
        - lines_changed
        - additions
        - deletions
      type: object
    TaskReviewSubjectPullRequest:
      additionalProperties: false
      properties:
        additions:
          format: int64
          minimum: 0
          type: integer
        branch_name:
          minLength: 1
          type: string
        checks_failed:
          format: int64
          minimum: 0
          type: integer
        checks_passed:
          format: int64
          minimum: 0
          type: integer
        checks_total:
          format: int64
          minimum: 0
          type: integer
        ci_status:
          enum:
            - pending
            - passed
            - failed
          type: string
        commits:
          format: int64
          minimum: 0
          type: integer
        deletions:
          format: int64
          minimum: 0
          type: integer
        html_url:
          minLength: 1
          type: string
        lines_changed:
          format: int64
          minimum: 0
          type: integer
        pr_number:
          format: int64
          minimum: 1
          type: integer
        review_check_conclusion:
          enum:
            - success
            - failure
            - cancelled
            - neutral
          type: string
        review_trigger:
          enum:
            - automatic
            - comment_command
          type: string
        state:
          enum:
            - open
            - closed
            - merged
          type: string
        title:
          type: string
      required:
        - pr_number
        - html_url
        - title
        - checks_passed
        - checks_failed
        - checks_total
        - commits
        - lines_changed
        - additions
        - deletions
        - review_trigger
      type: object
    TaskRunContext:
      additionalProperties: false
      properties:
        started_at:
          minLength: 1
          type: string
        workspace_id:
          minLength: 1
          type: string
      required:
        - workspace_id
        - started_at
      type: object
    TaskRuntimeTiming:
      discriminator:
        mapping:
          active:
            $ref: '#/components/schemas/TaskRuntimeTimingActive'
          inactive:
            $ref: '#/components/schemas/TaskRuntimeTimingInactive'
        propertyName: state
      oneOf:
        - $ref: '#/components/schemas/TaskRuntimeTimingInactive'
        - $ref: '#/components/schemas/TaskRuntimeTimingActive'
    TaskSlashCommand:
      additionalProperties: true
      properties:
        description:
          type: string
        input:
          additionalProperties: true
          properties:
            hint:
              type: string
          required:
            - hint
          type: object
        name:
          type: string
      required:
        - name
        - description
      type: object
    TaskSource:
      enum:
        - manual
        - ci
        - sentry
        - linear
        - slack
        - automation
        - pr_review
      type: string
    TaskUsage:
      additionalProperties: false
      properties:
        tokens_in:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        tokens_out:
          format: int64
          maximum: 9007199254740991
          minimum: 0
          type: integer
        vm_uptime_seconds:
          format: int64
          minimum: 0
          type: integer
      required:
        - tokens_in
        - tokens_out
        - vm_uptime_seconds
      type: object
    ToolDisplay:
      additionalProperties: false
      properties:
        blocks:
          items:
            $ref: '#/components/schemas/DisplayBlock'
          type: array
        label:
          minLength: 1
          type: string
        primary:
          minLength: 1
          type: string
        secondary:
          minLength: 1
          type: string
      required:
        - label
      type: object
    CIFailedEventData:
      additionalProperties: false
      properties:
        check_suite_id:
          format: int64
          minimum: 0
          type: integer
        conclusion:
          enum:
            - failure
          type: string
        failed_checks:
          items:
            additionalProperties: false
            properties:
              conclusion:
                minLength: 1
                type: string
              id:
                format: int64
                minimum: 0
                type: integer
              name:
                minLength: 1
                type: string
            required:
              - name
              - id
              - conclusion
            type: object
          type: array
        head_sha:
          minLength: 1
          type: string
        repo:
          minLength: 1
          type: string
      required:
        - head_sha
        - conclusion
        - repo
        - failed_checks
      type: object
    CIPassedEventData:
      additionalProperties: false
      properties:
        check_suite_id:
          format: int64
          minimum: 0
          type: integer
        conclusion:
          enum:
            - success
          type: string
        head_sha:
          minLength: 1
          type: string
        repo:
          minLength: 1
          type: string
      required:
        - check_suite_id
        - head_sha
        - conclusion
        - repo
      type: object
    DoneEventData:
      additionalProperties: false
      properties:
        message_id:
          minLength: 1
          type: string
        usage:
          $ref: '#/components/schemas/UsageStats'
      required:
        - message_id
      type: object
    ErrorEventData:
      additionalProperties: false
      properties:
        failure_kind:
          enum:
            - auth_expired
            - out_of_credits
            - provider_overloaded
            - subscription_disabled
            - provider_error
          type: string
        message:
          minLength: 1
          type: string
        usage:
          $ref: '#/components/schemas/UsageStats'
      required:
        - message
      type: object
    QuestionEventData:
      discriminator:
        mapping:
          ask_user:
            $ref: '#/components/schemas/QuestionEventDataAskUser'
          propose_plan:
            $ref: '#/components/schemas/QuestionEventDataProposePlan'
          stop_task:
            $ref: '#/components/schemas/QuestionEventDataStopTask'
        propertyName: toolName
      oneOf:
        - $ref: '#/components/schemas/QuestionEventDataAskUser'
        - $ref: '#/components/schemas/QuestionEventDataProposePlan'
        - $ref: '#/components/schemas/QuestionEventDataStopTask'
    WorkspaceLifecycleEventData:
      additionalProperties: false
      properties:
        message:
          minLength: 1
          type: string
        phase:
          enum:
            - starting
            - provisioning_machine
            - booting_workspace
            - preparing_workspace
            - starting_agent
            - ready
            - suspending
            - suspended
            - waiting_for_suspend
            - resuming
            - resumed
            - recovering
            - recovered
          type: string
      required:
        - phase
        - message
      type: object
    PromptContext:
      additionalProperties: false
      properties:
        attachments:
          items:
            $ref: '#/components/schemas/Attachment'
          type: array
        files:
          items:
            $ref: '#/components/schemas/FileReference'
          type: array
      type: object
    MessageEventCard:
      discriminator:
        mapping:
          auto_rebase:
            $ref: '#/components/schemas/AutoRebaseMessageEvent'
          ci_failure:
            $ref: '#/components/schemas/CIFailureMessageEvent'
          external:
            $ref: '#/components/schemas/ExternalMessageEvent'
          pr_comment:
            $ref: '#/components/schemas/PRCommentMessageEvent'
          pr_review:
            $ref: '#/components/schemas/PRReviewMessageEvent'
        propertyName: kind
      oneOf:
        - $ref: '#/components/schemas/PRCommentMessageEvent'
        - $ref: '#/components/schemas/CIFailureMessageEvent'
        - $ref: '#/components/schemas/AutoRebaseMessageEvent'
        - $ref: '#/components/schemas/PRReviewMessageEvent'
        - $ref: '#/components/schemas/ExternalMessageEvent'
    AskUserToolResponse:
      additionalProperties: false
      properties:
        data:
          additionalProperties: false
          properties:
            answers:
              additionalProperties:
                items:
                  format: int64
                  minimum: -1
                  type: integer
                type: array
              type: object
            customAnswers:
              additionalProperties:
                type: string
              type: object
          required:
            - answers
          type: object
        tool_name:
          enum:
            - ask_user
          type: string
      required:
        - tool_name
        - data
      type: object
    ProposePlanToolResponse:
      additionalProperties: false
      properties:
        data:
          additionalProperties: false
          properties:
            approved:
              type: boolean
            feedback:
              type: string
          required:
            - approved
          type: object
        tool_name:
          enum:
            - propose_plan
          type: string
      required:
        - tool_name
        - data
      type: object
    TaskTimelineTool:
      additionalProperties: false
      properties:
        display:
          $ref: '#/components/schemas/ToolDisplay'
        error:
          type: string
        id:
          minLength: 1
          type: string
        input:
          additionalProperties: true
          properties: {}
          type: object
        itemType:
          enum:
            - user_message
            - assistant_message
            - reasoning
            - plan
            - command_execution
            - file_change
            - file_read
            - mcp_tool_call
            - dynamic_tool_call
            - collab_agent_tool_call
            - web_search
            - web_fetch
            - image_view
            - task_tracking
            - subagent_invocation
            - review_entered
            - review_exited
            - context_compaction
            - error
            - unknown
          type: string
        name:
          minLength: 1
          type: string
        provider:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        result:
          type: string
        status:
          enum:
            - input-streaming
            - input-available
            - output-available
            - output-error
            - output-denied
            - approval-responded
            - approval-requested
          type: string
      required:
        - id
        - name
        - input
        - status
        - display
      type: object
    TaskAwaitingInputMessage:
      additionalProperties: false
      properties:
        kind:
          enum:
            - message
          type: string
      required:
        - kind
      type: object
    TaskAwaitingInputPlan:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/ProposePlanToolInput'
        kind:
          enum:
            - plan
          type: string
        tool_id:
          minLength: 1
          type: string
      required:
        - kind
        - tool_id
        - input
      type: object
    TaskAwaitingInputQuestions:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/AskUserToolInput'
        kind:
          enum:
            - questions
          type: string
        tool_id:
          minLength: 1
          type: string
      required:
        - kind
        - tool_id
        - input
      type: object
    TaskRuntimeTimingActive:
      additionalProperties: false
      properties:
        active_started_at:
          minLength: 1
          type: string
        state:
          enum:
            - active
          type: string
      required:
        - state
        - active_started_at
      type: object
    TaskRuntimeTimingInactive:
      additionalProperties: false
      properties:
        state:
          enum:
            - inactive
          type: string
      required:
        - state
      type: object
    DisplayBlock:
      discriminator:
        mapping:
          badge:
            $ref: '#/components/schemas/BadgeDisplayBlock'
          code:
            $ref: '#/components/schemas/CodeDisplayBlock'
          diff:
            $ref: '#/components/schemas/DiffDisplayBlock'
          file_tree:
            $ref: '#/components/schemas/FileTreeDisplayBlock'
          image:
            $ref: '#/components/schemas/ImageDisplayBlock'
          key_value:
            $ref: '#/components/schemas/KeyValueDisplayBlock'
          link:
            $ref: '#/components/schemas/LinkDisplayBlock'
          markdown:
            $ref: '#/components/schemas/MarkdownDisplayBlock'
          note:
            $ref: '#/components/schemas/NoteDisplayBlock'
          search_results:
            $ref: '#/components/schemas/SearchResultsDisplayBlock'
          terminal:
            $ref: '#/components/schemas/TerminalDisplayBlock'
          todo_list:
            $ref: '#/components/schemas/TodoListDisplayBlock'
          video:
            $ref: '#/components/schemas/VideoDisplayBlock'
        propertyName: type
      oneOf:
        - $ref: '#/components/schemas/TerminalDisplayBlock'
        - $ref: '#/components/schemas/DiffDisplayBlock'
        - $ref: '#/components/schemas/CodeDisplayBlock'
        - $ref: '#/components/schemas/FileTreeDisplayBlock'
        - $ref: '#/components/schemas/MarkdownDisplayBlock'
        - $ref: '#/components/schemas/KeyValueDisplayBlock'
        - $ref: '#/components/schemas/BadgeDisplayBlock'
        - $ref: '#/components/schemas/LinkDisplayBlock'
        - $ref: '#/components/schemas/SearchResultsDisplayBlock'
        - $ref: '#/components/schemas/TodoListDisplayBlock'
        - $ref: '#/components/schemas/ImageDisplayBlock'
        - $ref: '#/components/schemas/VideoDisplayBlock'
        - $ref: '#/components/schemas/NoteDisplayBlock'
    UsageStats:
      additionalProperties: false
      properties:
        cachedInputTokens:
          format: int64
          minimum: 0
          type: integer
        cachedWriteTokens:
          format: int64
          minimum: 0
          type: integer
        cost:
          format: double
          minimum: 0
          type: number
        inputTokens:
          format: int64
          minimum: 0
          type: integer
        metadata:
          additionalProperties: true
          properties: {}
          type: object
        outputTokens:
          format: int64
          minimum: 0
          type: integer
        provider:
          enum:
            - codex
            - claude-code
            - opencode
            - cursor
          type: string
        reasoningOutputTokens:
          format: int64
          minimum: 0
          type: integer
        totalTokens:
          format: int64
          minimum: 0
          type: integer
      required:
        - inputTokens
        - outputTokens
      type: object
    QuestionEventDataAskUser:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/AskUserToolInput'
        toolId:
          minLength: 1
          type: string
        toolName:
          enum:
            - ask_user
          type: string
        usage:
          $ref: '#/components/schemas/UsageStats'
      required:
        - toolId
        - toolName
        - input
      type: object
    QuestionEventDataProposePlan:
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/ProposePlanToolInput'
        toolId:
          minLength: 1
          type: string
        toolName:
          enum:
            - propose_plan
          type: string
        usage:
          $ref: '#/components/schemas/UsageStats'
      required:
        - toolId
        - toolName
        - input
      type: object
    QuestionEventDataStopTask:
      additionalProperties: false
      properties:
        input:
          additionalProperties: false
          properties: {}
          type: object
        toolId:
          minLength: 1
          type: string
        toolName:
          enum:
            - stop_task
          type: string
        usage:
          $ref: '#/components/schemas/UsageStats'
      required:
        - toolId
        - toolName
        - input
      type: object
    Attachment:
      additionalProperties: false
      properties:
        data:
          minLength: 1
          type: string
        filename:
          minLength: 1
          type: string
        mediaType:
          minLength: 1
          type: string
      required:
        - filename
        - mediaType
        - data
      type: object
    FileReference:
      additionalProperties: false
      properties:
        include:
          type: boolean
        path:
          minLength: 1
          type: string
        selection:
          $ref: '#/components/schemas/FileSelection'
      required:
        - path
        - include
      type: object
    AutoRebaseMessageEvent:
      additionalProperties: false
      properties:
        baseBranch:
          minLength: 1
          type: string
        branch:
          minLength: 1
          type: string
        headSha:
          minLength: 1
          type: string
        kind:
          enum:
            - auto_rebase
          type: string
        mergeableState:
          minLength: 1
          type: string
        prNumber:
          format: int64
          minimum: 1
          type: integer
        reason:
          type: string
        repo:
          $ref: '#/components/schemas/MessageEventRepo'
        url:
          format: uri
          type: string
      required:
        - kind
        - repo
        - prNumber
      type: object
    CIFailureMessageEvent:
      additionalProperties: false
      properties:
        branch:
          minLength: 1
          type: string
        checks:
          items:
            additionalProperties: false
            properties:
              conclusion:
                minLength: 1
                type: string
              jobId:
                format: int64
                type: integer
              name:
                minLength: 1
                type: string
              summary:
                type: string
            required:
              - name
              - conclusion
              - jobId
            type: object
          type: array
        kind:
          enum:
            - ci_failure
          type: string
        prNumber:
          format: int64
          minimum: 1
          type: integer
        repo:
          $ref: '#/components/schemas/MessageEventRepo'
        url:
          format: uri
          type: string
      required:
        - kind
        - repo
        - checks
      type: object
    ExternalMessageEvent:
      additionalProperties: false
      properties:
        data:
          additionalProperties: true
          properties: {}
          type: object
        kind:
          enum:
            - external
          type: string
        source:
          enum:
            - slack
            - linear
            - sentry
            - email
          type: string
      required:
        - kind
        - source
      type: object
    PRCommentMessageEvent:
      additionalProperties: false
      properties:
        action:
          minLength: 1
          type: string
        author:
          additionalProperties: false
          properties:
            association:
              minLength: 1
              type: string
            login:
              minLength: 1
              type: string
            type:
              minLength: 1
              type: string
          required:
            - login
          type: object
        body:
          type: string
        branch:
          minLength: 1
          type: string
        kind:
          enum:
            - pr_comment
          type: string
        line:
          format: int64
          minimum: 1
          type: integer
        path:
          minLength: 1
          type: string
        prNumber:
          format: int64
          minimum: 1
          type: integer
        repo:
          $ref: '#/components/schemas/MessageEventRepo'
        reviewState:
          minLength: 1
          type: string
        url:
          format: uri
          type: string
      required:
        - kind
        - repo
        - prNumber
        - author
        - body
      type: object
    PRReviewMessageEvent:
      additionalProperties: false
      properties:
        action:
          minLength: 1
          type: string
        branch:
          minLength: 1
          type: string
        headSha:
          minLength: 1
          type: string
        kind:
          enum:
            - pr_review
          type: string
        prNumber:
          format: int64
          minimum: 1
          type: integer
        repo:
          $ref: '#/components/schemas/MessageEventRepo'
        url:
          format: uri
          type: string
      required:
        - kind
        - repo
        - prNumber
        - headSha
      type: object
    ProposePlanToolInput:
      additionalProperties: true
      properties:
        plan:
          type: string
        summary:
          type: string
      required:
        - summary
        - plan
      type: object
    AskUserToolInput:
      additionalProperties: true
      properties:
        questions:
          items:
            additionalProperties: true
            properties:
              multiSelect:
                type: boolean
              options:
                items:
                  additionalProperties: true
                  properties:
                    description:
                      type: string
                    label:
                      type: string
                  required:
                    - label
                  type: object
                type: array
              question:
                type: string
            required:
              - question
              - options
            type: object
          type: array
      required:
        - questions
      type: object
    BadgeDisplayBlock:
      additionalProperties: false
      properties:
        text:
          type: string
        tone:
          enum:
            - muted
            - success
            - error
            - info
            - warning
          type: string
        type:
          enum:
            - badge
          type: string
      required:
        - type
        - text
        - tone
      type: object
    CodeDisplayBlock:
      additionalProperties: false
      properties:
        content:
          type: string
        language:
          type: string
        path:
          type: string
        type:
          enum:
            - code
          type: string
      required:
        - type
        - content
      type: object
    DiffDisplayBlock:
      additionalProperties: false
      properties:
        hunks:
          items:
            additionalProperties: false
            properties:
              lines:
                items:
                  additionalProperties: false
                  properties:
                    kind:
                      enum:
                        - add
                        - remove
                        - context
                      type: string
                    text:
                      type: string
                  required:
                    - kind
                    - text
                  type: object
                type: array
              newStart:
                format: int64
                minimum: 0
                type: integer
              oldStart:
                format: int64
                minimum: 0
                type: integer
            required:
              - oldStart
              - newStart
              - lines
            type: object
          type: array
        path:
          type: string
        type:
          enum:
            - diff
          type: string
      required:
        - type
        - hunks
      type: object
    FileTreeDisplayBlock:
      additionalProperties: false
      properties:
        entries:
          items:
            additionalProperties: false
            properties:
              kind:
                enum:
                  - file
                  - directory
                type: string
              path:
                minLength: 1
                type: string
            required:
              - path
              - kind
            type: object
          type: array
        type:
          enum:
            - file_tree
          type: string
      required:
        - type
        - entries
      type: object
    ImageDisplayBlock:
      additionalProperties: false
      properties:
        alt:
          type: string
        type:
          enum:
            - image
          type: string
        url:
          minLength: 1
          type: string
      required:
        - type
        - url
      type: object
    KeyValueDisplayBlock:
      additionalProperties: false
      properties:
        rows:
          items:
            additionalProperties: false
            properties:
              label:
                type: string
              tone:
                enum:
                  - muted
                  - success
                  - error
                  - info
                  - warning
                type: string
              value:
                type: string
            required:
              - label
              - value
            type: object
          type: array
        type:
          enum:
            - key_value
          type: string
      required:
        - type
        - rows
      type: object
    LinkDisplayBlock:
      additionalProperties: false
      properties:
        label:
          type: string
        type:
          enum:
            - link
          type: string
        url:
          minLength: 1
          type: string
      required:
        - type
        - url
      type: object
    MarkdownDisplayBlock:
      additionalProperties: false
      properties:
        text:
          type: string
        type:
          enum:
            - markdown
          type: string
      required:
        - type
        - text
      type: object
    NoteDisplayBlock:
      additionalProperties: false
      properties:
        text:
          type: string
        tone:
          enum:
            - muted
            - success
            - error
            - info
            - warning
          type: string
        type:
          enum:
            - note
          type: string
      required:
        - type
        - text
        - tone
      type: object
    SearchResultsDisplayBlock:
      additionalProperties: false
      properties:
        groups:
          items:
            additionalProperties: false
            properties:
              file:
                minLength: 1
                type: string
              matches:
                items:
                  additionalProperties: false
                  properties:
                    line:
                      format: int64
                      minimum: 0
                      type: integer
                    text:
                      type: string
                  required:
                    - line
                    - text
                  type: object
                type: array
            required:
              - file
              - matches
            type: object
          type: array
        pattern:
          type: string
        type:
          enum:
            - search_results
          type: string
      required:
        - type
        - groups
      type: object
    TerminalDisplayBlock:
      additionalProperties: false
      properties:
        background:
          type: boolean
        command:
          type: string
        cwd:
          type: string
        exitCode:
          format: int64
          type: integer
        stderr:
          type: string
        stdout:
          type: string
        type:
          enum:
            - terminal
          type: string
      required:
        - type
        - command
      type: object
    TodoListDisplayBlock:
      additionalProperties: false
      properties:
        items:
          items:
            additionalProperties: false
            properties:
              status:
                enum:
                  - pending
                  - in_progress
                  - completed
                type: string
              text:
                type: string
            required:
              - text
              - status
            type: object
          type: array
        type:
          enum:
            - todo_list
          type: string
      required:
        - type
        - items
      type: object
    VideoDisplayBlock:
      additionalProperties: false
      properties:
        poster:
          type: string
        type:
          enum:
            - video
          type: string
        url:
          minLength: 1
          type: string
      required:
        - type
        - url
      type: object
    FileSelection:
      additionalProperties: false
      properties:
        endLine:
          format: int64
          minimum: 1
          type: integer
        startLine:
          format: int64
          minimum: 1
          type: integer
      required:
        - startLine
        - endLine
      type: object
    MessageEventRepo:
      additionalProperties: false
      properties:
        name:
          minLength: 1
          type: string
        owner:
          minLength: 1
          type: string
      required:
        - owner
        - name
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http

````